/*
 * Created on 10/05/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package arsm;
import interfaces.*;
import org.ietf.jgss.*;
import types.Stream;



/**
 * @author Braga Junior.
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ArsmImpl extends ArsmPOA{
	private GSSManager manager;
	private ContextManager contextManager;
	private GSSName targetName;
	private static  byte NO_CONTEXT=1;
	private static  String id = "ARSM"; 
	private boolean isWrap=false;
	private GSSCredential serverCreds;
	private types.Stream emptyStream=new types.Stream();
	private ArsmLogger arsmLogger =  ArsmLogger.init();
	
public ArsmImpl(boolean wrap)
{  
	System.out.println("Waiting for clients...");
	emptyStream.value=new byte[1];
	emptyStream.value[0]=(byte) 0;
	manager = GSSManager.getInstance();
	contextManager = new ContextManager(manager);
	isWrap = wrap;
}


public synchronized types.Stream test(types.Stream testStr)
{
		
 //   MessagePacket msgOut=new MessagePacket(testStr);
 //   msgOut = new MessagePacket(requestSignature(testStr));
 //   return msgOut.getStream();
	  arsmLogger.info("Arsm Tester");
	  MessagePacket msgOut;
      MessagePacket msgIN=new MessagePacket(testStr);
      msgIN = checkSignature(msgIN);
      msgOut = requestSignature(msgIN);
      return msgOut.getStream();
}
public synchronized types.Stream sendReceiveStream(types.Stream inStream)	
{
	GSSContext context;
	MessagePacket recMessage = new  MessagePacket(inStream);
	MessagePacket sendMessage = new MessagePacket();
	String msgId=new String(recMessage.getId());
	if(Signature.verbose)
	{
		System.out.println("Receving message from client... ");
	}
	if(Signature.verbose)
		{
	  		recMessage.print();
		}	

	try{
		
		context = contextManager.getContext(msgId + "%");
		if(Signature.verbose)
		{
			arsmLogger.info("Token received of "+ msgId);
		}
		sendMessage=new MessagePacket(getId(),context.acceptSecContext(
				recMessage.getMsg(), 0, 
				recMessage.getMsg().length));
		if(context.isEstablished())
		{
			System.out.println("Context accepted: " + context.getSrcName().toString());
			if(Signature.verbose)
			{
				arsmLogger.info("Context accepted: " + context.getSrcName().toString());
			}
			contextManager.putNewContext(msgId + "%",context);
		}
	
	} catch (Exception e)
	{
		arsmLogger.severe("Accept context error of " + msgId + ": " + e.getMessage());
		System.err.println("Accept context error:" + e.getMessage() );
	}
	
	
	if(Signature.verbose)
	{
		System.out.println("Sending Stream to client...\n");
		sendMessage.print();
	}
	if(sendMessage.getStream().value.length != 0)
	{
		return sendMessage.getStream();
	}else{
		arsmLogger.severe("Empty token " + msgId + " \n");
		System.err.println("empty...\n");
		return (types.Stream) emptyStream;

	}
}



public synchronized MessagePacket requestSignature(MessagePacket message)
{
	GSSContext context = contextManager.getContext(new String(message.getId()));
	return Signature.requestSignature(message,context,isWrap);
}
public synchronized MessagePacket checkSignature(MessagePacket messageSigned)
{
	GSSContext context = contextManager.getContext(new String(messageSigned.getId()));
	return Signature.checkSignature(messageSigned,context,isWrap);
}

public synchronized void finish(Stream streamFinish)
{ 
		MessagePacket msgFinish = new MessagePacket(streamFinish);
		contextManager.removeContext(msgFinish);
}
public synchronized Stream checkForeignSignature(Stream doubleStrSigned)
{	
	
	MessagePacket doubleSigned = new MessagePacket(doubleStrSigned);
	String idCheckString="UNKNOWN";
	try{
		doubleSigned=checkSignature(doubleSigned); // unsign
		byte[] idCheck = doubleSigned.getId(); //id
		idCheckString= new String(idCheck);
		if(idCheckString.indexOf("/ARSM@")==-1)
		{
			return null;
		}
		MessagePacket signed = new MessagePacket(new Stream(doubleSigned.getMsg()));
		signed = checkSignature(signed);
		return (requestSignature(new MessagePacket(idCheck,signed.getMsg()))).getStream();
	} catch(Exception e)
	{
		arsmLogger.severe("CheckForeignSignature error ->" + idCheckString + ": " + e.getMessage());
		System.err.println("CheckForeignSignature error:" + e.toString());
	}
	return null;
}
public synchronized Stream requestForeignSignature(Stream strSigned)
{
	MessagePacket MPSigned = new MessagePacket(strSigned);
	String idRequesterString="UNKNOWN";
	try{
		MPSigned=checkSignature(MPSigned); // unsign
		byte[] idRequester = MPSigned.getId(); //id
		idRequesterString = new String(idRequester);
		if(idRequesterString.indexOf("/ARSM@")==-1)
		{
			return null;
		}
		MPSigned=new MessagePacket(new Stream(MPSigned.getMsg()));
		MPSigned=requestSignature(MPSigned);
		MPSigned = new MessagePacket(idRequester,MPSigned.getStream().value);
		MPSigned=requestSignature(MPSigned);
		return MPSigned.getStream(); 
	} catch(Exception e)
	{
		arsmLogger.severe("RequestForeignSignature error -> " + idRequesterString + ": " + e.getMessage());
		System.err.println("RequestForeignSignature error ->:" + e.toString());
	}
	return null;
}

byte[] getId()
{
	return id.getBytes();
}

}

