/*
 * Created on 21/05/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */

package arsm;
import interfaces.*;
import org.ietf.jgss.*;
import java.security.*;
import java.util.*;
import types.Stream;


/**
 * @author Braga Junior.
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class ContextManager {
	GSSManager	manager;
	private Map contextMap = new HashMap() ;
	private ArsmLogger rsmLogger =  ArsmLogger.init();
	public ContextManager(GSSManager	gssmng)
	{
		manager = gssmng;
		// Instantiate and initialize a security context that will
		// wait for an establishment request token from the client
	}
	private void verify(String id,GSSContext context) throws  GeneralSecurityException
{
		try{
		
			if((context.getSrcName().toString().compareTo(id))!=0)
			{
				rsmLogger.severe("Error creating context. The principal is " + context.getSrcName().toString()+ 
								" but it said " + id );
				throw new GeneralSecurityException("Error ID compare.");
			}
		}catch (GSSException e){
			System.err.println("Error creating context: " + e.getMessage() );
		}
		
}
	public synchronized GSSContext getContext(String id)
	{
		GSSContext retCtx =(GSSContext) contextMap.get(id);
				try{
					if( retCtx ==null)
				{
					retCtx =manager.createContext((GSSCredential)null) ;
					retCtx.requestConf(true);
					retCtx.requestMutualAuth(true);
					retCtx.requestReplayDet(true);
					retCtx.requestSequenceDet(false);
					contextMap.put(id,retCtx);
				} 					
				} catch (GSSException e)
				{
					rsmLogger.severe("Error creating context for id" +id + ": " + e.getMessage() );
					System.err.println("Error creating context: " + e.getMessage() );
				}
			
	return retCtx;
}
	public synchronized void putNewContext(String idStr, GSSContext idContext )
	{
		GSSContext retCtx =(GSSContext) contextMap.get(idStr);
		contextMap.remove(idStr);
		idStr=idStr.substring(0,idStr.length()-1);
	        if(contextMap.get(idStr)!=null)
		{	
			contextMap.remove(idStr);
			rsmLogger.warning("Attempt to double register for " + idStr + ".");
			System.out.println("Attempt to double register for " + idStr + ".");
		}
		contextMap.put(idStr,idContext);
	}
	public synchronized void removeContext(MessagePacket msgSign)
		{
			String Id = new String(msgSign.getMsg());
			GSSContext idContext = (GSSContext) contextMap.get(Id);
			if(idContext != null)
			{
				MessagePacket msgTest = Signature.requestSignature(msgSign,idContext,true);
				if(msgTest.getStream().value.length != 0  )
				{
					rsmLogger.info("Context removed: " + Id);
					System.out.println("Context removed: " + Id ); 
					try
					{
						idContext.dispose();
						contextMap.remove(msgSign.getMsg().toString());
					}catch(GSSException e){
						System.err.println("Disposing context: " + e.getMessage() );
					}
					
				}
			}
		
		}
		
}
