/*
 * Created on 08/06/2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package arsm;
import java.security.MessageDigest;
import java.security.NoSuchAlgorithmException;

import types.Stream;
import org.ietf.jgss.*;

/**
 * @author Braga Junior.
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class Signature {
private static ArsmLogger arsmLogger =  ArsmLogger.init();	
public static boolean verbose=false;
private static int headerLength=7;
	

	/**
	 *  Sign Verify mtethod
	 * Message signed format:
	 * [sign length][message length][sign][message]
	 * sign length - 2 bytes
	 * message length - 5 byte
	 * message sign 
	 * message 
	 */
	public static MessagePacket checkSignature(MessagePacket messageSigned,GSSContext context,boolean isWrap)
	{
		byte[] unwrapMessage;
		MessageProp msgProp = new MessageProp(isWrap);
		String msgId=new String(messageSigned.getId());
		if(verbose){
				System.out.println("Verifying signed message id=" +  msgId);
				arsmLogger.info("Verifying signed message id=" + msgId);
			}
		
	try{ 
		       unwrapMessage=context.unwrap(messageSigned.getMsg(),0,messageSigned.getMsgLength(),msgProp);

		       
		} catch (GSSException e)
		{
			System.err.println("Error verifing siginature " + msgId + ": " + e.getMessage());
			arsmLogger.severe("Error verifing siginature " + msgId + ": " + e.getMessage());
			return null;
	
		}
		//TODO Verify msgProp, more details  gap  and  Unseq Tokens?
		if(verbose)
		{
		
			System.err.println("Message Verify:  Duplicate=" + 
			msgProp.isDuplicateToken() + "\tGap=" + msgProp.isGapToken() 
			+ "\tOld=" + msgProp.isOldToken() + 
             "\tUnseq="+ msgProp.isUnseqToken() );
			System.err.println("Message Verify sucessfull");
		
		}
		
		return new MessagePacket(messageSigned.getId(),unwrapMessage);

	
	}
	
	/**
	 *  Sign Message mtethod
	 * return 
	 * Message signed format:
	 * [sign length][message length][sign][message]
	 * sign length - 2 bytes
	 * message length - 4 bytes
	 * message sign 
	 * message 
	 */
	public static MessagePacket requestSignature(MessagePacket message,GSSContext context,boolean isWrap)
	{
		
		byte wrapMessage[];
		String msgId=new String(message.getId());
		MessageProp msgProp = new MessageProp(isWrap);
		if(verbose){
				System.out.println("Signing message.");
				arsmLogger.info("Signing message of" + msgId);
			}
		
		try{
			wrapMessage=context.wrap(message.getMsg(),0,message.getMsgLength(),msgProp);

		} catch (GSSException e)
		{
			System.err.println("Signing message error: " + e.getMessage() );
			arsmLogger.info("Signing message error for " + msgId + ":" + e.getMessage());
			return null;
	
		}
		 MessagePacket msgRet =  new MessagePacket(message.getId(),wrapMessage);
		if(verbose) msgRet.print();
		return msgRet;
	}
	public static byte[] messageDigest(byte[] inputStream)
    {
	byte[] digest=null;
        try {

            MessageDigest md = MessageDigest.getInstance("SHA");
            md.update(inputStream);
	    digest=md.digest();
        } catch (NoSuchAlgorithmException e) {
		System.err.println("Message Digest Error: " + e.toString());
        }
		return digest;
	
    }
    public static byte[] verifyDigest(byte[] messageDigest)
	{
		try{
		MessageDigest md = MessageDigest.getInstance("SHA");
		
		int mdLength=md.getDigestLength();
		int messageDigestLength = messageDigest.length;
		byte[] message = new byte[messageDigestLength -  mdLength];
		byte[] digest = new byte[mdLength];
		for(int i=0;i<message.length;i++)	
		{
			message[i]=messageDigest[i+mdLength];	
		}
		for(int i=0;i<mdLength;i++)
                {
                        digest[i]=messageDigest[i];
                }	
		md.update(message);
		if(MessageDigest.isEqual(digest,md.digest())) return message;
        	} catch (NoSuchAlgorithmException e) {
			System.err.println("Compare Message Digest Error: " + e.toString());

 			}
		return null;
	}

	
}
