#ifndef ExecutionManagerStub_HPP
#define ExecutionManagerStub_HPP

#include <string>
//#include <vector>

struct lua_State;

using std::string;
//using std::vector;

  //IMPORTANT: This class is not multithread-safe. Users of this class must ensure that
  // 'state' is safely isolated when concurrently accessed
  class ExecutionManagerStub{

  private:
    struct lua_State * state;

  public:
    ExecutionManagerStub(lua_State * aState, const string & execManagerIor);

    void reportExecutionStarted(const string & appMainRequestId, 
                                const string & appNodeRequestId, 
                                const string & lrmIor, 
                                const int & restartId, 
                                const string & appId);
  
    int reportExecutionFinished(const string & appMainRequestId, 
                                const string & appNodeRequestId, 
                                const int & restartId,
                                int exitStatus);
  };

#endif // ExecutionManagerStub_HPP


