#ifndef OfferSpecs_HPP
#define OfferSpecs_HPP


#include <string>

using namespace std;

 /**
   OfferSpecs - Holds information about an execution that was
   accepted by a LRM

   @author Andrei Goldchleger
 */
 class OfferSpecs{

  private:

    string lrmIor_;    /**< The IOR of the LRM that accepted this execution*/
    string requestId_; /**< The id of the accepted execution */
    string lrmRequestId_;



  public:

  //Named parameter idiom---------------------------------------------------

  OfferSpecs & lrmIor(const string & aLrmIor){
      lrmIor_= aLrmIor;
      return (*this);
  }

  OfferSpecs & requestId(const string & aRequestId){
    requestId_= aRequestId;
    return (*this);
  }

  OfferSpecs & lrmRequestId(const string & aLrmRequestId){
    lrmRequestId_= aLrmRequestId;
    return (*this);
  }


//    void setLrmIor(const string & lrmIor_){lrmIor = lrmIor_; }
//    void setRequestId(const string & requestId_){requestId = requestId_; }

  //Getters---------------------------------------------------------------

   const string & lrmIor(){return lrmIor_; }
   const string & requestId(){return requestId_; }
   const string & lrmRequestId(){return lrmRequestId_; }
 };


#endif//OfferSpecs_HPP

