package asctGui;


import types.AppDescription;
import types.BinaryDescription;
import types.ContentDescription;
import interfaces.ApplicationRepositoryPackage.ApplicationNotFoundException;
import interfaces.ApplicationRepositoryPackage.ApplicationRegistrationException;
import interfaces.ApplicationRepositoryPackage.BinaryCreationException;
import interfaces.ApplicationRepositoryPackage.BinaryNotFoundException;
import interfaces.ApplicationRepositoryPackage.DirectoryCreationException;
import interfaces.ApplicationRepositoryPackage.DirectoryNotEmptyException;
import interfaces.ApplicationRepositoryPackage.DirectoryNotFoundException;

public interface ApplicationRepositoryWrapperInterface {

	public boolean createDirectory(String dirname) throws DirectoryCreationException;

	public void removeDirectory(String dirname) throws DirectoryNotFoundException, DirectoryNotEmptyException;
	
	public ContentDescription[] listContents(String dirname) throws DirectoryNotFoundException ;
	
	public void registerApplication(String dirname, String appame) throws ApplicationRegistrationException, DirectoryCreationException;
	
	public AppDescription getAppDescription(String dir_name) throws ApplicationNotFoundException, DirectoryNotFoundException ;
	
	public void uploadApplicationBinary(BinaryDescription binDesc, byte[] app) throws BinaryCreationException, ApplicationNotFoundException, DirectoryNotFoundException;
	
//	public byte[] getApplicationBinary(String bin_name);
	
	public void deleteApplicationBinary(String dir_name, String bin_name, String platform) throws ApplicationNotFoundException, DirectoryNotFoundException, BinaryNotFoundException;

	public void unregisterApplication(String dirname, String appname) throws ApplicationNotFoundException, DirectoryNotFoundException, DirectoryNotEmptyException;

//	public int numberOfEntries(String dirname) throws DirectoryNotFoundException;

//	public boolean isDirectory(String dirname) throws DirectoryNotFoundException;

	public String getRootName();
	
}
