package asctGui;
import javax.swing.JFrame;
import javax.swing.JToolBar;
import javax.swing.JButton;
import javax.swing.JPanel;


import java.awt.BorderLayout;
import javax.swing.JScrollPane;
import javax.swing.DefaultListModel;
import javax.swing.ListSelectionModel;
import javax.swing.border.TitledBorder;

import java.awt.event.MouseAdapter;




  //Class----------------------------------------------------------------------

  /**
    RegisteredApplicationsPanel - Holds names of the applications registered in the
    Application Repository.

    @author Andrei Goldchleger
    @date February/2004

  */
  class ListPanel extends JPanel{

    //Fields------------------------------------------------------------------
    private JScrollPane appScrollPane;
    protected DefaultListModel appListModel;
    protected ItemTooltippedList appList;

    //Costructor--------------------------------------------------------------
     ListPanel(String listName){


      //Botton Panel
      this.appScrollPane = new JScrollPane();
      this.appListModel = new DefaultListModel();
      this.appList = new ItemTooltippedList(appListModel);
      appList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
      appScrollPane.getViewport().add(appList, null);

      //Final assembly
      this.setLayout(new BorderLayout());
      //this.add(topPanel, BorderLayout.NORTH);
      this.add(appScrollPane, BorderLayout.CENTER);
      this.setBorder(new TitledBorder(listName));


    }

    //-------------------------------------------------------------------------
    public void addItem(Object item){
      synchronized(appListModel){
        appListModel.addElement(item);
      }  
    }

    //-------------------------------------------------------------------------
    public Object getSelectedItem(){

      if (appList.getSelectedIndex() >= 0){
        synchronized(appListModel){
          return appListModel.get(appList.getSelectedIndex());
        }  
      }
      return null;
    }

    //-------------------------------------------------------------------------
    public void addListMouseListener(MouseAdapter adapter) {
      appList.addMouseListener(adapter);
    }

  }//class

